public class Candidato {
  private var eleito: Bool
  private var numero: Int
  private var nome: String
  private var votos: Int

  //Variaveis que podem ser modificadas e/ou nulas:
  private var posicao: Int?
  private var partido: Partido?

  public init(eleito: Bool, numero: Int, nome: String, votos: Int) {
      self.eleito = eleito
      self.numero = numero
      self.nome = nome
      self.votos = votos
  }

  public func isEleito () -> Bool {
    return self.eleito
  }

  public func getNome() -> String {
    return self.nome
  }

  public func getVotos() -> Int {
    return self.votos
  }

  public func getPosicao() -> Int {
    return self.posicao!
  }

  public func setPosicao(posicao: Int) {
    self.posicao = posicao
  }

  public func getCandidato ()-> String {
    return ("\(self.nome)")
  }

  public func setPartido(partido: Partido){
    self.partido = partido
  }

  public func imprimeCandidato ()-> String {
    /*Variaveis auxiliares para a leitura de partido dos candidatos
            e sua coligacao. Esses dados serão armazendados em uma
            String chamada de aux.

    */
    let auxPartido: Partido? = self.partido
    let listaPartidos: [Partido] = auxPartido!.getColigacao()!.getPartido()
    var aux: String = ""
    /*Condicao para checar se a coligacao lida nao é a ultima da lista:
        Se não:
            insere separador '/' para separar os partidos
        Se sim:
            nao insere separador
    */
    if (listaPartidos.count > 1) {
      for partido in listaPartidos {
        if !(partido.getNome() == listaPartidos.last?.getNome()) {
          aux += partido.getNome() + " / "
        }
        else {
          aux += partido.getNome()
        }
      }
      var aux1 = self.nome + " (" + auxPartido!.getNome()
      aux1 += ", " + String(self.votos)
      aux1 += " votos) - Coligação "
      return (aux1 + aux)
    }
    else {
      aux = self.nome + " (" + auxPartido!.getNome()
      aux += ", " + String(self.votos)
      aux += " votos) - Coligação "
      return aux
    }
  }

}
