public class Coligacao {

  private var partido : [Partido] = []

  public init() {}

  public func getPartido ()-> [Partido] {
    return partido
  }

  public func setPartido (partido:Partido){
    return self.partido.append(partido)
  }

  //Função que retorna em int a quantidade de eleitos do Objeto Coligação:
  public func totaldeCandidatosEleitos() -> Int{
    var soma = 0
    for partido in self.partido {
      soma += partido.qtdCandidatosEleitos()
    }
    return soma
  }

  //Função que retorna em int o total de votos do Objeto Coligação:
  public func totaldeVotosColigacao() -> Int{
		var soma = 0;
    for partido in self.partido {
			soma += partido.qtdVotosNominais();
		}
		return soma;
	}

  //Funcao de imprensao da Coligacao
  public func imprimeColigacao () -> String {
    var aux = "Coligacao: "
    let lista = self.partido
    for partido in self.partido {
      if !(partido.getNome() == lista.last?.getNome()) {
        aux += partido.getNome() + " / "
      }
      else {
        aux += partido.getNome()
      }
    }
    /*Condição para checar se houve mais de um candidato eleitos
        Se sim:
            insere no plural
        Se não:
            insere no singular:
    */
    if (self.totaldeCandidatosEleitos() <= 1) {
      aux += ", " + String(self.totaldeVotosColigacao())
      aux += " votos, " + String(self.totaldeCandidatosEleitos())
      aux += " candidato eleito"
    }
    else {
      aux += ", " + String(self.totaldeVotosColigacao())
      aux += " votos, " + String(self.totaldeCandidatosEleitos())
      aux += " candidatos eleitos"
    }
    return aux
  }

}
