import Foundation

public class Leitura {

  /* Método construtor da classe:
  * Função:
  * 	Método de leitura linha a linha usando delimitadores
  * 		como resultado teremos as classes criadas
  * 		e inseridas nas listas
  */
  public init (listaCandidatos: inout [Candidato], listaPartidos: inout [Partido], listaColigacoes: inout [Coligacao]){

    //NUmero de linhas do arquivo:
    var nLinha: Int = 0
    //Status do Candidato :
    var eleito: Bool = false
    //Numero do Candidato:
    var numero: Int
    //Nome do Candidato
    var nome: String
    //Votos do Candidato:
    var votos: Int

    // Criacao de instancia do FileHandle e entrada do input com o nome do arquivo:
    print("Insira nome do arquivo e sua extensão: ")
    let response = readLine()
    let arquivo: FileHandle? = FileHandle(forReadingAtPath: response!)

    //LEITURA DO ARQUIVO:
    if arquivo != nil {
      let dados = arquivo?.readDataToEndOfFile()
      let componentes = NSString(data: dados!, encoding: String.Encoding.utf8.rawValue)

      //Separacao das linhas
      let linhas = componentes!.components(separatedBy: "\n")

      for linha in linhas {
        nLinha += 1
        if (nLinha < linhas.count){
          //Separacao da linha por delimitador ; em um array
          var palavras : [String] = linha.components(separatedBy: ";")
          //Descatar primeira linha:
          if (nLinha != 1){

            let auxEleito = palavras[0].characters.first

            //Checagem se Candidato foi eleito:
            if (auxEleito == "*"){
              eleito = true
            }

            //Setando numero,nome e votos pelas posicoes do array:
            numero = Int(palavras[1])!
            nome = palavras[2]
            let auxVotos = palavras[4].replacingOccurrences(of: ".", with: "")
            votos = Int(auxVotos)!

            //Criando Candidato:
            let candidato = Candidato(eleito:eleito,numero:numero,nome:nome,votos:votos)
            //Adicionando candidatos na lista:
            listaCandidatos.append(candidato)

            //Dividindo partido e coligacaoes caso a linha possua " - ":
            if (palavras[3].range(of:"-") != nil){
              var divide = palavras[3].components(separatedBy: " - ")
              //Dividindo os partidos de uma coligacao
              let nomePartido = divide[0]
              divide = divide[1].components(separatedBy: " / ")

              //Variavel auxiliar para checar se Partido já está na lista:
              var contador = 0

              /*Verificando se partido ja está na lista:
                      se sim = não soma ao contador e adiciona novo candidato ao partido
                      se não = soma 1 ao contador
              */
              for auxPartido in listaPartidos {
                if (auxPartido.getNome() == nomePartido) {
                  auxPartido.setCandidato(candidato: candidato)
                  candidato.setPartido(partido: auxPartido)
                  contador += 1
                }
              }

              //Caso contador esteja zerado, cria-se novo partido e o adiciona a lista:
              if (contador == 0){
                //Criando Partido:
                let partido: Partido = Partido(nome: nomePartido)
                //Criando Coligacao:
                let coligacao: Coligacao = Coligacao()

                partido.setCandidato(candidato: candidato)
                candidato.setPartido(partido: partido)
                listaPartidos.append(partido)

                //Criando partidos e adicionando coligacoes que estao contidas na Variavel divide
                for auxPartido in divide {
                  if !(auxPartido == nomePartido){
                    let novoPartido: Partido = Partido(nome: auxPartido)
                    listaPartidos.append(novoPartido)
                    coligacao.setPartido(partido: novoPartido)
                    novoPartido.setColigacao(coligacao: coligacao)
                  }
                  else if (auxPartido == nomePartido){
                    coligacao.setPartido(partido: partido)
                  }
                }
                partido.setColigacao(coligacao: coligacao)
                listaColigacoes.append(coligacao)
              }
            }

            //Caso a linha não possua " - " Candidato nao possui coligacao
            else{

              /*Verificando se partido ja está na lista:
                      se sim = não soma ao contador e adiciona novo candidato ao partido
                      se não = soma 1 ao contador
              */
              var contador = 0
              for auxPartido in listaPartidos {
                if (auxPartido.getNome() == palavras[3]) {
                  auxPartido.setCandidato(candidato: candidato)
                  candidato.setPartido(partido: auxPartido)
                  contador += 1
                }
              }

              //Caso contador esteja zerado, cria-se novo partido e o adiciona a lista:
              if (contador == 0) {
                let partido: Partido = Partido(nome: palavras[3])
                let coligacao: Coligacao = Coligacao()
                coligacao.setPartido(partido: partido)
                partido.setCandidato(candidato: candidato)
                partido.setColigacao(coligacao: coligacao)
                candidato.setPartido(partido: partido)
                listaPartidos.append(partido)
                listaColigacoes.append(coligacao)
              }
            }
          }
          eleito = false
        }
      }

      //Fechando o arquivo
      arquivo?.closeFile()
    }
    else {
      print("Ooops! Erro na abertura do arquivo!")
    }
  }
}
