public class Partido {

  private var nome: String
  private var candidatos: [Candidato] = []
  private var coligacao: Coligacao?

  public init(nome: String) {
      self.nome = nome
  }

  public func getNome() -> String {
    return self.nome
  }

  public func getPartido ()-> String {
    return ("\(self.nome)")
  }

  public func getCandidato ()-> [Candidato] {
    return candidatos
  }

  public func setCandidato (candidato: Candidato) {
    return self.candidatos.append(candidato)
  }

  public func setColigacao (coligacao:Coligacao) {
    return self.coligacao = coligacao
  }

  public func getColigacao ()-> Coligacao? {
    return self.coligacao
  }

  //Função que calcula a quantidade de votos nominais do partido(retorno em int):
  public func qtdVotosNominais() -> Int{
    var soma = 0
    for candidato in self.candidatos {
      soma += Int(candidato.getVotos())
    }
    return soma
  }

  /*Funcao que retorna em uma String contendo:
      - Quantidade de votos nominais
      - Quantidade de candidatos do partido eleitos
  */
  public func votacaoNominal() -> String{
   var soma = 0
   var eleitos = 0
   for candidato in self.candidatos {
     soma += candidato.getVotos()
     if (candidato.isEleito()) {
        eleitos += 1;
      }
    }
    //Checagem para verificar se a imprensao é no plural ou não:
    if (eleitos <= 1) {
      return (String(soma) + " votos, " + String(eleitos) + " candidato eleito");
    }
    return (String(soma) + " votos, " + String(eleitos) + " candidatos eleitos");
  }

  //Funcao que retorna o total de votos nominais usando o NumberFormat:
  public func votacaoNominalInt() -> Int{
    var soma = 0
    for candidato in self.candidatos {
      soma += candidato.getVotos()
    }
    return soma
  }

  //Função que retorna a qunatidade de candidatos eleitos em inteiro:
  public func qtdCandidatosEleitos() -> Int{
    var qtd = 0
    for candidato in self.candidatos {
      if (candidato.isEleito()) {
        qtd += 1
      }
    }
    return qtd;
  }

  //Funcao de imprensao do Partido
  public func imprimePartido () -> String {
    var aux = ""
    for candidato in self.candidatos {
      aux += "\n" + candidato.imprimeCandidato()
    }
    return aux
  }
}
