public var listaCandidatos: [Candidato] = []
public var listaPartidos: [Partido] = []
public var listaColigacoes: [Coligacao] = []

var vagas = 0
var tvotos = 0

var leiura = Leitura(listaCandidatos: &listaCandidatos, listaPartidos: &listaPartidos, listaColigacoes: &listaColigacoes)

for candidato in listaCandidatos {
  if (candidato.isEleito()) {
    vagas += 1
  }
  tvotos += candidato.getVotos()
}
//IMPRIMINDO QUANTIDADE DE VAGAS:
print ("Número de vagas: \(vagas)\n")

//IMPRIMINDO LISTA CANDIDATOS:
print("Vereadores eleitos:")
var i = 1
for candidato in listaCandidatos {
  if (candidato.isEleito()){
    print (String(i) + " - " + candidato.imprimeCandidato())
  }
  candidato.setPosicao(posicao: i)
  i += 1
}

var listaCandidatosVotos = listaCandidatos

listaCandidatosVotos.sort(by: { (primeiro: Candidato, segundo: Candidato) -> Bool in
primeiro.getVotos() > segundo.getVotos()
})

//IMPRIMINDO LISTA CANDIDATOS ORDENADA POR VOTOS:
print("\n\nCandidatos mais votados (em ordem decrescente de votação e respeitando número de vagas):")
i = 1
for candidato in listaCandidatosVotos {
  if (i <= vagas){
    print (String(i) + " - " + candidato.imprimeCandidato())
  }
  candidato.setPosicao(posicao: i)
  i += 1
}

/*IMPRIMINDO CANDIDATOS DA LISTACANDIDATOS:
        DA PRIMEIRA LISTA QUE NAO ESTAO NA SEGUNDA:
*/
var subListaCandidatos1 = listaCandidatos[0...(vagas-1)]
var subListaCandidatos2 = listaCandidatosVotos[0...(vagas-1)]

print("\n\nTeriam sido eleitos se a votação fosse majoritária, e não foram eleitos:\n" +
          "(com sua posição no ranking de mais votados)")
for candidato in subListaCandidatos2 {
  if !(subListaCandidatos1.contains(where: { $0.getNome() == candidato.getNome()})) {
    print (String(candidato.getPosicao()) + " - " + candidato.imprimeCandidato())
  }
}

/*IMPRIMINDO CANDIDATOS DA LISTACANDIDATOS:
              DA PRIMEIRA SEGUNDA QUE NAO ESTAO NA PRIMEIRA:
      */
print("\n\nEleitos, que se beneficiaram do sistema proporcional:\n" +
          "(com sua posição no ranking de mais votados)")
for candidato in subListaCandidatos1 {
  if !(subListaCandidatos2.contains(where: { $0.getNome() == candidato.getNome()})) {
    print(String(candidato.getPosicao()) + " - " + candidato.imprimeCandidato())
  }
}

//IMPRIMINDO LISTA DE COLIGAÇÕES POR VOTAÇÃO NOMINAL:
listaColigacoes.sort(by: { (primeiro: Coligacao, segundo: Coligacao) -> Bool in
primeiro.totaldeVotosColigacao() > segundo.totaldeVotosColigacao()
})
print("\n\nVotação (nominal) das coligações e número de candidatos eleitos:")
i = 1
for coligacao in listaColigacoes {
  print(String(i) + " - " + coligacao.imprimeColigacao())
  i += 1
}

//IMPRIMINDO LISTA PARTIDOS:
listaPartidos.sort(by: { (primeiro: Partido, segundo: Partido) -> Bool in
primeiro.qtdVotosNominais() > segundo.qtdVotosNominais()
})
print("\n\nVotação (nominal) dos partidos e número de candidatos eleitos:")
i = 1
for partido in listaPartidos {
  if !(partido.getCandidato().isEmpty){
    print (String(i) + " - " + partido.getNome() + ", " + String(partido.votacaoNominal()))
  }
  i += 1
}

print("\n\nTotal de votos nominais: \(tvotos)")
